 ;////////////////////////////////////////////////////////////////////////////
 ;
 ;  Copyright (C) Microsoft Corporation.  All Rights Reserved.
 ;
 ;  File:       d3dx9.h
 ;  Content:    D3DX utility library
 ;
 ;////////////////////////////////////////////////////////////////////////////
IFDEF __D3DX_INTERNAL__
.ERR <Incorrect D3DX header used>
ENDIF 
IFNDEF __D3DX9_H__
__D3DX9_H__ equ
 ; Defines
;Include \masm32\sdk\limits.SDK			;librairie math vc++,pas de traduction
D3DX_DEFAULT	equ	< -1>
D3DX_DEFAULT_NONPOW2	equ	< -2>
D3DX_DEFAULT_FLOAT	equ	<FLT_MAX>

 ; Includes
Include d3d9.inc
Include d3dx9math.inc
Include d3dx9core.inc
Include d3dx9mesh.inc
Include d3dx9tex.inc
Include d3dx9shader.inc
Include d3dx9effect.inc 
Include d3dx9shape.inc
Include d3dx9anim.inc
 ; Errors
_FACDD	equ	<0876h>
ENDIF  ;__D3DX9_H__
