
;ID3DXBaseMesh
;la fentre est cre,sans tre visible
;on lui donne des possibilites graphiques directx
;################################################################
InitD3D PROC  hWnd:DWORD 
			Local  d3dpp:D3DPRESENT_PARAMETERS
			Local FAILED:SDWORD
			Local  retour:DWORD
			ZEROLOCALES retour	
			
		invoke Direct3DCreate9,D3D_SDK_VERSION
		.if eax != 0
			mov ppvIDirect3D9,eax
			mov retour,eax
			mov d3dpp.Windowed,TRUE
			mov d3dpp.SwapEffect,D3DSWAPEFFECT_DISCARD
			mov d3dpp.BackBufferFormat,D3DFMT_UNKNOWN
		    	mov d3dpp.EnableAutoDepthStencil, TRUE
			mov d3dpp.AutoDepthStencilFormat,D3DFMT_D16			
			;la fonction suivante ne fonctionne pas dans WM_CREATE
			;D3DADAPTER_DEFAULT utilisation du device par dfaut,si plusieurs carte graphiques
			;on peut en spcifi une particulire 
			;D3DDEVTYPE_HAL ,on demande le HAL,Hardware device au lieu du software device
			;D3DCREATE_SOFTWARE_VERTEXPROCESSING ,Software vertex processing permet d'utiliser
			;toutes les cartes graphiques.Les cartes graphiques supportant le hardware vertex processing
			;offrent des performances notablement suprieures
			;Ceci accroit  les performances D3DCREATE_MIXED_VERTEXPROCESSING D3DCREATE_SOFTWARE_VERTEXPROCESSING
			IDirect3D9 CreateDevice,D3DADAPTER_DEFAULT,D3DDEVTYPE_HAL, hWnd,\
                                      D3DCREATE_SOFTWARE_VERTEXPROCESSING,\
                                      addr d3dpp, addr ppvIDirect3DDevice9
			.if eax == D3D_OK		;0
				;rajout
    				; Turn off culling, so we see the front and back of the triangle
				IDirect3DDevice9  SetRenderState,D3DRS_CULLMODE, D3DCULL_NONE 

    				;Turn off D3D lighting, since we are providing our own vertex colors
    				IDirect3DDevice9  SetRenderState,D3DRS_ZENABLE, TRUE 		
				mov retour,1	;sinon retour = 0
				;la fonction fournit le pointeur sur l'interface IDirect3DDevice9
			.endif 
			;c'est fait ,on peut maintenant visualiser la fentre 
			;la fentre D3D doit tre rafraichit de manire particulire dans WM_PAINT			
			
		.endif
 FindeInitD3D:
         mov eax,retour
         ret
InitD3D endp
;tout de suite aprs avoir crer le device
;################################################################

InitVB PROC uses esi edi ebx
			Local CNT:DWORD,index,arg1,arg2,EndChain, BytesUnused
			Local theta:REAL4
			Local PasseQword:REAL8
			Local  retour:DWORD
		;on se passe du customvertex en pile,inutile
         	mov retour,0
		mov arg1,0

		;le vertex buffer est un FVF buffer (accs com)
		;il faut crer un buffer FVF puis le remplir
		IDirect3DDevice9 CreateVertexBuffer,50*2*sizeof(CUSTOMVERTEX),\
			0, D3DFVF_CUSTOMVERTEX,D3DPOOL_DEFAULT,addr ppvIDirect3DVertexBuffer9, NULL
		;la fonction retourne une interface pour manipuler le buffer
		.if eax == D3D_OK	
			;remplir le buffer com
			;obtenir un pointeur en data com
			IDirect3DVertexBuffer9 Lock1,0,50*2*sizeof(CUSTOMVERTEX),addr pvertices,NULL
			;ppbData ,pvertices peut entrainer confusion avec original
			.if eax == D3D_OK			
				;on a le pointeur en data com
				comment 
    for( DWORD i=0; i<50; i++ )
    {
        FLOAT theta = (2*D3DX_PI*i)/(50-1);
        pVertices[2*i+0].position = D3DXVECTOR3( sinf(theta),-1.0f, cosf(theta) );
        pVertices[2*i+0].normal   = D3DXVECTOR3( sinf(theta), 0.0f, cosf(theta) );
        pVertices[2*i+1].position = D3DXVECTOR3( sinf(theta), 1.0f, cosf(theta) );
        pVertices[2*i+1].normal   = D3DXVECTOR3( sinf(theta), 0.0f, cosf(theta) );
    }
				

	mov CNT,50				;va effectuer 50 boucles,index fixe la valeur de 0  49
	mov index,0
	mov edi,pvertices
	.while(CNT)
		;petite bavure a l'cran,modifier 50-1 par 50 -2
		;calculer theta (2*PI*Index)/(50-1)
		FINIT
		FLDPI
		fst PasseQword		
		mov arg2,2
		fimul arg2
		fst PasseQword		
		fimul index
		fst PasseQword
		push 49
		fidiv dword ptr [esp]
		fst PasseQword		
		pop eax
		fstp	theta			;rsultat arrondi en DWORD [stack fpu -1]		
		;----------- charger les vecteurs -------------------------------	
		mov edi,index
		shl edi,1
		imul edi,sizeof CUSTOMVERTEX
		add edi,pvertices
		;-----
		mov dword ptr [edi][CUSTOMVERTEX.position.x],FUNC(Sinus,theta)
		mov dword ptr [edi][CUSTOMVERTEX.position.y],RETR4(-1.0f)
		mov dword ptr [edi][CUSTOMVERTEX.position.z],FUNC(Cosinus,theta)
		;-------------------		
		mov dword ptr [edi][CUSTOMVERTEX.normal.x],FUNC(Sinus,theta)
		mov dword ptr [edi][CUSTOMVERTEX.normal.y],RETR4(0.0f)
		mov dword ptr [edi][CUSTOMVERTEX.normal.z],FUNC(Cosinus,theta)
		;-------------------
		mov ecx,index
		lea edi,[ecx+ecx+1]	;index *3
		imul edi,sizeof CUSTOMVERTEX
		add edi,pvertices		
			
		mov dword ptr [edi][CUSTOMVERTEX.position.x],FUNC(Sinus,theta)
		mov dword ptr [edi][CUSTOMVERTEX.position.y],RETR4(1.0f)
		mov dword ptr [edi][CUSTOMVERTEX.position.z],FUNC(Cosinus,theta)
		;-------------------
		mov dword ptr [edi][CUSTOMVERTEX.normal.x],FUNC(Sinus,theta)
		mov dword ptr [edi][CUSTOMVERTEX.normal.y],RETR4(0.0f)
		mov dword ptr [edi][CUSTOMVERTEX.normal.z],FUNC(Cosinus,theta)
		;-------------------					
					
	dec CNT
	inc index
	.endw
	mov edi,pvertices ;debug
				
				IDirect3DVertexBuffer9 Unlock
				mov retour,1
			.endif
		.endif
		;le pointeur en data com est dfinitivement perdu
 FindeInitVB:
         mov eax,retour
         ret
InitVB endp

;################################################################
Sinus PROC  AngleRadian:DWORD 
			Local   result:DWORD
			FINIT
			fld	dword PTR AngleRadian	;s+1
			fsin
			fstp	DWORD PTR result		;s-1
			mov eax,result
         ret
Sinus endp

;################################################################

Cosinus PROC  AngleRadian:DWORD 
		Local result:DWORD
			FINIT
			fld	DWORD PTR AngleRadian
			fcos
			fstp	DWORD PTR result
			mov eax,result
         ret
Cosinus endp

;################################################################

SetupMatrices PROC uses edi esi
	;incertitude,alignement en pile ?
		Local iTime:DWORD,time:DWORD
		align 16		;obligatoire
		local matWorld:D3DXMATRIXA16 
		align 16
		local matView:D3DXMATRIXA16
		align 16
		local matProj:D3DXMATRIXA16		
		LOcal vEyePt	:STD3DXVECTOR3
		Local vLookatPt	:STD3DXVECTOR3
		Local vUpVec	:STD3DXVECTOR3
		Local PasseQword	:REAL8
		Local Angle		:DWORD
		Local  retour:DWORD
		ZEROLOCALES retour
		
		invoke D3DXMatrixIdentity,addr matWorld
		;fonction du temps,diffrente de matrices
		invoke timeGetTime ;temps en ms
		mov time,eax
		;-------- calcul de l'angle de rotation en radians --------------
		fild	dword ptr time	;charge le nombre de millimes de tour
		fdiv	QWORD PTR cinqcents	;on retrouve une fraction de tour en radians < 6,28
		fstp	DWORD PTR Angle		;charg dans l'angle
		invoke D3DXMatrixRotationX,addr matWorld,Angle		
		IDirect3DDevice9 SetTransform, D3DTS_WORLD,addr matWorld
		;-----------------------------------------------------
		
		; Set up our view matrix. A view matrix can be defined given an eye point,
		; a point to lookat, and a direction for which way is up. Here, we set the
		;eye five units back along the z-axis and up three units, look at the
		;origin, and define "up" to be in the y-direction.
		LOADD3DXVECTOR3 vEyePt,0.0f, 3.0f,-5.0f
		LOADD3DXVECTOR3 vLookatPt,0.0f, 0.0f, 0.0f
		LOADD3DXVECTOR3 vUpVec,0.0f,1.0f, 0.0f
		invoke D3DXMatrixLookAtLH,addr matView,addr vEyePt,addr vLookatPt,addr vUpVec 
		IDirect3DDevice9 SetTransform,D3DTS_VIEW,addr matView
		
		;For the projection matrix, we set up a perspective transform (which
		;transforms geometry from 3D view space to 2D viewport space, with
		; a perspective divide making objects smaller in the distance). To build
		;a perpsective transform, we need the field of view (1/4 pi is common),
		;the aspect ratio, and the near and far clipping planes (which define at
		;what distances geometry should be no longer be rendered).
		invoke D3DXMatrixPerspectiveFovLH,addr matProj,UnQuartPi,FR4(1.0f),FR4(1.0f),FR4(100.0f)
		IDirect3DDevice9 SetTransform,D3DTS_PROJECTION,addr matProj
		
         mov retour,1
  ; For our world matrix, we will just rotate the object about the y-axis.

 FindeSetupMatrices:
         mov eax,retour
         ret

SetupMatrices endp

;################################################################
SetupLights PROC 
			Local  mtrl:D3DMATERIAL9
			Local time:DWORD,arg1,arg2
			Local  vecDir:STD3DXVECTOR3
			local  light:D3DLIGHT9
			Local  retour:DWORD
			ZEROLOCALES retour
			
	; Set up a material. The material here just has the diffuse and ambient
	;colors set to yellow. Note that only one material can be used at a time.
	
	mov mtrl.Diffuse.r,RETR4(1.0f)
	mov  mtrl.Ambient.r,eax
	;--------------------------------
	mov mtrl.Diffuse.g,eax
	mov mtrl.Ambient.g,eax
	;------------------------------------
	mov mtrl.Diffuse.b,RETR4(0.0f)
	mov mtrl.Ambient.b,eax
	;------------------------------------
	mov mtrl.Diffuse.a,RETR4(1.0f)
	mov mtrl.Ambient.a,eax 
	
	IDirect3DDevice9 SetMaterial,addr mtrl
	;Set up a white, directional light, with an oscillating direction.
	; Note that many lights may be active at a time (but each one slows down
	; the rendering of our scene). However, here we are just using one. Also,
	; we need to set the D3DRS_LIGHTING renderstate to enable lighting
	mov light.type1,D3DLIGHT_DIRECTIONAL
	mov light.Diffuse.r,RETR4(1.0f)
	mov light.Diffuse.g,eax
	mov light.Diffuse.b,eax
	;calcul du temps
	invoke timeGetTime ;temps en ms
	mov time,eax
	mov arg1,RETR4(350.0f)
	FINIT
	fild time
	fdiv arg1
	fstp time	;timeGetTime()/350.0f stack fpu=0
	invoke Cosinus,time
	mov arg1,eax
	invoke Sinus,time
	mov arg2,eax
	;charge vecDir
	lea ecx,vecDir
	invoke D3DXVECTOR3,arg1,FR4(1.0f),arg2
	;--- D3DXVec3Normalize( (D3DXVECTOR3*)&light.Direction, &vecDir );---------
	invoke D3DXVec3Normalize,addr light.Direction,addr vecDir
	
	mov light.Range,RETR4(1000.0f)
	IDirect3DDevice9 SetLight,0,addr light
	IDirect3DDevice9 LightEnable,0, TRUE
	IDirect3DDevice9 SetRenderState,D3DRS_LIGHTING, TRUE 

	;Finally, turn on some ambient light. 0202020h NOT GOOD
	IDirect3DDevice9 SetRenderState,D3DRS_AMBIENT, 0202020h

 FindeSetupLights:
         mov eax,retour
         ret
SetupLights endp

;################################################################



;################################################################
Render PROC 
			Local Zreel:DWORD
			Local  retour:DWORD
         mov retour,1
	.if ppvIDirect3DDevice9 != 0
		;arriere plan bleu
		invoke RGBcolorARGB,00FF0000h,NULL		;bleu
		mov ecx,eax
		;erreur traduction D3DCLEAR_ZBUFFER
		;invalid_call avec +D3DCLEAR_ZBUFFER  oubli de  d3dpp.EnableAutoDepthStencil = TRUE;
		IDirect3DDevice9 Clear,0, NULL,D3DCLEAR_TARGET+D3DCLEAR_ZBUFFER,ecx,FR4(1.0f), 0 
		IDirect3DDevice9 BeginScene
		.if eax != D3D_OK	
			call MessageNotD3D_OK
		.else
		
        		; Setup the world, view, and projection matrices
			IF Exceptions EQ 1
				XPEXCEPT SetupLights	
				XPEXCEPT SetupMatrices
			ELSE
				invoke SetupLights
        			invoke SetupMatrices
			ENDIF
			
			;----------------- ajout triangle -------------------------
			; Draw the triangles in the vertex buffer. This is broken into a few
			; steps. We are passing the vertices down a "stream", so first we need
			; to specify the source of that stream, which is our vertex buffer. Then
			; we need to let D3D know what vertex shader to use. Full, custom vertex
			; shaders are an advanced topic, but in most cases the vertex shader is
			; just the FVF, so that D3D knows what type of vertices we are dealing
			; with. Finally, we call DrawPrimitive() which does the actual rendering
			; of our geometry (in this case, just one triangle).
			IDirect3DDevice9 SetStreamSource,0,ppvIDirect3DVertexBuffer9, 0, sizeof CUSTOMVERTEX
			IDirect3DDevice9 SetFVF,D3DFVF_CUSTOMVERTEX
			;D3DPT_TRIANGLESTRIP D3DPT_TRIANGLELIST
			IDirect3DDevice9 DrawPrimitive,D3DPT_TRIANGLESTRIP, 0,2*50-2			
			;----------------------------------------------------------
			IDirect3DDevice9 EndScene
		.endif
		IDirect3DDevice9 Present,NULL, NULL, NULL, NULL
	.endif
	
 FindeRender:
         mov eax,retour
         ret
MessageNotD3D_OK:	
	pop eax    ;toujours garder l'quilibre de la pile en push pop
	invoke MessageBox,NULL,SADR("Render not D3D_OK") ,SADR("Erreur Quitte"),MB_OK
	jmp FindeRender ;retour = 0
retn
Render endp
;la fonction ne fait qu'une seule chose
;plac les rels dans la structure
;reoit l'adresse de la structure par ecx
;_this,est un terme,en principe,reserv au pointeur com(introduisant le ppv)
;ii,aucune manipulation de pointeur,tout est direct
;plus confus ,ce n'est pas possible
;################################################################
D3DXVECTOR3 PROC  fx:REAL4,  fy:REAL4,  fz:REAL4 
		local _this:DWORD
		Local  retour:DWORD
      mov retour,1
	mov	_this, ecx
;il faut comprendre structure.x = fx	structure = STD3DXVECTOR3
; x = fx;
	mov	eax, _this
	fld	DWORD PTR fx
	fstp	DWORD PTR [eax]		
;  y = fy;
	mov	eax, _this
	fld	DWORD PTR fy
	fstp	DWORD PTR [eax+4]
; z = fz;
	mov	eax, _this
	fld	DWORD PTR fz
	fstp	DWORD PTR [eax+8]
;

	PuPo retour,_this
 FindeD3DXVECTOR3:
         mov eax,retour
         ret
D3DXVECTOR3 endp

D3DXMatrixIdentity PROC pOut:DWORD	; D3DXMatrixIdentity, COMDAT
;zro gnral fait par zro locales
; 1928 : 
; 1929 :     pOut->m[0][0] = pOut->m[1][1] = pOut->m[2][2] = pOut->m[3][3] = 1.0f;

	mov	eax,pOut
	fld1
	fstp	DWORD PTR [eax+60]
	mov	ecx,pOut
	fld1
	fstp	DWORD PTR [ecx+40]
	mov	edx, DWORD PTR pOut
	fld1
	fstp	DWORD PTR [edx+20]
	mov	eax,pOut
	fld1
	fstp	DWORD PTR [eax]

	mov	eax, DWORD PTR pOut

	ret
D3DXMatrixIdentity ENDP	; D3DXMatrixIdentity



;################################################################
RGBcolorARGB PROC  RGB:DWORD,  ARGB:DWORD 
			Local  retour:DWORD
		;plein les mirettes
		;Red Green Blue RGB donne aprs decalage 00BGR
		;ARGB donne aprs dcalage ARGB
		;ARGB color macro pour extraction,extraire sparment du RGB
		;0000FFFFh jaune RGB B=00 G=FF R=FF     ARGB 0FFFFFF00h
		;#define RGB(r, g ,b)  (r | g << 8 | b << 16 )
		;#define D3DCOLOR_ARGB(a,r,g,b)((a)&0xff)<<24)|(r)<<16)|g <<8|(b)		
			
      mov retour,0
	.if ARGB == 0	
		;on veut une couleur ARGB
		and edx,0FF000000h	;
		mov eax,RGB
		and eax,0FF0000h  ;bleu
		shr eax,16		
		or edx,eax
		mov eax,RGB
		and eax,0FF00h	;green vert
		or edx,eax
		mov eax,RGB
		and eax,0FFh	;rouge
		shl eax,16
		or edx,eax
		mov retour,edx				
	.else		
		;on veut une couleur RGB
		and edx,0
		mov eax,ARGB
		and eax,0FF0000h  ;rouge
		shr eax,16		
		or edx,eax
		mov eax,ARGB
		and eax,0FF00h	;green vert
		or edx,eax
		mov eax,ARGB
		and eax,0FFh	;Bleu		
		shl eax,16
		or edx,eax
		mov retour,edx						
		
	.endif

 FindeRGBcolorARGB:
         mov eax,retour
         ret
RGBcolorARGB endp





;################################################################

Cleanup PROC      ;relache les interfaces
			Local  retour:DWORD
         mov retour,1
	.if ppvIDirect3DVertexBuffer9 != 0
		IDirect3DVertexBuffer9 Release
		mov ppvIDirect3DVertexBuffer9,0
	.endif

	.if ppvIDirect3DDevice9 != 0
		IDirect3DDevice9 Release
		mov ppvIDirect3DDevice9,0
	.endif
	.if ppvIDirect3D9 != 0
		IDirect3D9 Release
		mov ppvIDirect3D9,0
	.endif

 FindeCleanup:
         mov eax,retour
         ret
Cleanup endp





