

	HIWORD MACRO ParamFen
		mov eax,ParamFen
		shr eax,16
	ENDM
	LOWORD MACRO ParamFen
		mov eax,ParamFen
		and eax,0FFFFh
	ENDM

      FUNC MACRO parameters:VARARG
        invoke parameters
        EXITM <eax>
      ENDM

      PuPo MACRO M1, M2
        push M2
        pop  M1
      ENDM
 ; -------------------------
  ; determine an operand type
  ; -------------------------
;http://www.masm32.com/board/index.php?topic=2567.msg20304#msg20304
    op_type MACRO arg:REQ
      LOCAL result
      result = opattr(arg)
	EXITM %result
        IF result eq 37         ;; label, either local or global
          EXITM %1
        ELSEIF result eq 42     ;; GLOBAL var
          EXITM %2
        ELSEIF result eq 98     ;; LOCAL  var
          EXITM %3
        ELSEIF result eq 36     ;; immediate operand or constant
          EXITM %4
        ELSEIF result eq 48     ;; register
          EXITM %5
        ELSEIF result eq 805    ;; local procedure in code
          EXITM %6
        ELSEIF result eq 933    ;; external procedure or API call
          EXITM %7
        ENDIF
      EXITM %0                  ;; anything else
    ENDM
	LOADD3DXVECTOR3 MACRO adresse:REQ ,ARG1:REQ,ARG2:REQ,ARG3:REQ	;ARG1..REAL4
      LOCAL result
	Local var1
	local var2
	local var3
	result = opattr(adresse)
	.data
		var1 real4 ARG1
		var2 real4 ARG2
		var3 real4 ARG3
	.code			
	IF result eq 48
		Push var1
		pop dword ptr [adresse]
		Push var2
		pop dword ptr [adresse+4]	
		Push var3
		pop dword ptr [adresse+8]					
	ELSE
		lea ecx,adresse
		Push var1
		pop dword ptr [ecx]
		Push var2
		pop dword ptr [ecx+4]	
		Push var3
		pop dword ptr [ecx+8]							
	ENDIF
      ENDM

;un simple saut par dessus les datas en section code suffit
	InsTxt MACRO Name, Text:VARARG
	LOCAL lbl
		jmp lbl
		Name db Text,0
	lbl:
	ENDM

	return MACRO valeur
		mov eax,valeur
		ret
	ENDM
	
;en cas d'absence dans le source

      FUNC MACRO parameters:VARARG
        invoke parameters
        EXITM <eax>
      ENDM

; macro d'cran
	;usage	 mov resultat,HAUTEUR( Rct)             Rct est une structure RECT
	HAUTEUR MACRO Adrrect:REQ
		push ebx
		lea ebx,Adrrect
		mov     eax,(RECT ptr [ebx]).bottom   ; y bas origine coin haut gauche 0,0
		sub     eax,(RECT ptr [ebx]).top      ; y haut	
		pop ebx
	EXITM <eax>
	ENDM
	LARGEUR MACRO Adrrect:REQ
		push ebx
		lea ebx,Adrrect
		mov     eax,(RECT ptr [ebx]).right     ; x coin droit bas  origine coin haut gauche 0,0
		sub     eax, (RECT ptr [ebx]).left     ; x coin gauche haut 
		pop ebx
	EXITM <eax>
	ENDM
	
		ZEROLOCALES MACRO dernierelocale:REQ
			mov ecx,ebp
			lea edx,dernierelocale
			sub ecx,edx
			.if ecx != 0
				push edi
				mov edi,edx
				mov al,0
				cld
				rep stosb
				pop edi			
			.endif
		ENDM
	R4MOV MACRO dest,src
		local reel
		.const
		reel REAL4 src
		.code
		PUSH reel
		POP dest
	ENDM
	RETR4 MACRO src
		local reel
		.const
		reel REAL4 src
		.code
		mov eax,reel
		EXITM <eax>
	ENDM
	FR4 MACRO src
		local reel
		.data
		reel dd src
		.code
		EXITM<reel>
	ENDM
	; --------------------------------------------------------
    ; Cre une donne en data,renvoie l'tiquette de la chaine
    ; La cration du nom de l'tiquette est facultatif
    ; la macro vrifie la syntaxe des chaines et tiquettes
    ; ---------------------------------------------------------
      CREDATA MACRO quoted_text:REQ,NomdeChaine
		LOCAL Local_Etiquette,verif
	IFNB <NomdeChaine>			;present
		verif SUBSTR <NomdeChaine>,1,1
      		IFIDN verif,<">            ;si le premier caractere est "
			.ERR  <ETIQUETTE SUPRIMER les " >			
		ENDIF
	Local_Etiquette TEXTEQU <NomdeChaine>		;changer le nom d'tiquette
	ENDIF
	verif SUBSTR <quoted_text>,1,1				
	IFDIF verif,<">
		.ERR  <CHAINE AJOUTER LES " >
	ENDIF
	
		.data
		Local_Etiquette db quoted_text,0
		.code
		EXITM <Local_Etiquette>
      ENDM
    ; ----------------------------------------------------
    ; Sort l' adresse de la chaine crer, SADR("chaine")
    ; -----------------------------------------------------
      	SADR MACRO quoted_text:REQ,NomdeChaine
        	EXITM <ADDR CREDATA(quoted_text,NomdeChaine)>
      	ENDM
    ; ----------------------------------------------------
    ; Sort l' offset de la chaine crer, SOFF("chaine")
    ; -----------------------------------------------------
	SOFF MACRO quoted_text:REQ,NomdeChaine
        	EXITM <Offset CREDATA(quoted_text,NomdeChaine)>
      	ENDM	

  ; ---------------------------------------------------
  ; return an arguments specified in "num" from a macro
  ; argument list or "-1" if the number is out of range
  ; ---------------------------------------------------
    getarg MACRO num:REQ,args:VARARG
      LOCAL cnt, txt
      cnt = 0
      FOR arg, <args>
        cnt = cnt + 1
        IF cnt EQ num
          txt TEXTEQU <arg>     ;; set "txt" to content of arg num
          EXITM
        ENDIF
      ENDM
      IFNDEF txt
        txt TEXTEQU <-1>        ;; return -1 if num out of range
      ENDIF
      EXITM txt
    ENDM
	
  ; -----------------------------------------------
  ; count the number of arguments passed to a macro
  ; This is a slightly modified 1990 MASM 6.0 macro
  ; -----------------------------------------------
    argcount MACRO args:VARARG
      LOCAL cnt
      cnt = 0
      FOR item, <args>
        cnt = cnt + 1
      ENDM
      EXITM %cnt                ;; return as a number
    ENDM		
;la macro peut s'crire plus simplement
;mais hlas,la boucle FOR ... gnre un "internal error" lorsque le fichier inclus
;contient des macros,les macros argcount et getarg sont la pour y remdier
LIB  MACRO args:VARARG
	LOCAL acnt,buffer,var,boucle,buf1
	acnt = argcount(args)			;macro argcount , nb d'arguments
	var = 1
	:boucle
	buffer equ getarg(var,args)		;macro getarg

	buf1 CATSTR <include \masm32\include\>,buffer,<.inc>
	buf1

	buf1 CATSTR <includelib \masm32\lib\>,buffer,<.lib>
	buf1

	var = var + 1
	IF var LE acnt
	goto boucle
	ENDIF
ENDM


; macros d'cran

;HAUTEUR et LARGEUR permettent d'extraire ces dimensions d'une structure rectangle (RECT)

	;usage	 mov resultat,HAUTEUR( Rct)
	HAUTEUR MACRO Adrrect:REQ
		push ebx
		lea ebx,Adrrect
		mov     eax,(RECT ptr [ebx]).bottom                 ; y bas origine coin haut gauche 0,0
		sub     eax,(RECT ptr [ebx]).top	  			; y haut	
		pop ebx
	EXITM <eax>
	ENDM
	LARGEUR MACRO Adrrect:REQ
		push ebx
		lea ebx,Adrrect
		mov     eax,(RECT ptr [ebx]).right       ; x coin droit bas  origine coin haut gauche 0,0
		sub     eax, (RECT ptr [ebx]).left      ; x coin gauche haut 
		pop ebx
	EXITM <eax>
	ENDM
	comment 
	
	FRECT	STRUCT
		min POINT <>
		max POINT <>
	FRECT ENDS
	
;la dfinition de la structure RECT est  jeter aux oubliettes 
;dans .data     rect FRECT <>
;dans le code (pseudo code)
;	largeur = rect.max.x -rect.min.x
;     	hauteur = rect.max.y - rect.min.y
;Reference de tailles pour MoveWindow et CreateWindowEx,dans l'ordre
;	rect.min.x,rect.min.y,largeur,hauteur
;Facile!? me direz-vous,essayez maintenant de faire la mme chose avec RECT sans
;regarder winhelp.Je parie que vous n'y arrivez pas,ou alors vous la connaissez par coeur et ne vrifiez pas
;vos sources
;RECT est une blague de chez microsoft
	

;----------------------------- exceptions -------------------------------

	comment 
	lea edx,FindeProgramme
	invoke InstalleExceptions,SADR("c:\masm32\ref\dbghelp.dll"),\
			DebutdeProgramme,edx
	.if eax == 0
		jmp Findeminus
	.endif
	mov Hdbghelp,eax 
	

;--------------- macro pour exception ------------------------------------------------
;XP
	;remplacer invoke par XPEXCEPT ,c'est tout
	
	XPEXCEPT MACRO parameters:VARARG
		;ajouter dans les dclarations:    EXTERNDEF pileazertyswxc:DWORD	
		invoke AddVectoredExceptionHandler,1,HANDLER
		;viter de redescendre les adresses laisses en pile par la fonction,9
		push pileazertyswxc	;prserv les handlers prcdents
		mov eax,esp
		mov pileazertyswxc,eax		
		invoke parameters
		invoke RemoveVectoredExceptionHandler,HANDLER
		pop pileazertyswxc
	ENDM








	;usage
	;EXCEPT ("je me trouve dans macro.inc"),Nomproc,Param1,Param2.....
	;remplace: invoke Nomproc,Param1,Param2
	;-------- structures pour les HANDLERS ------------------------------



;--------------------- version 98 -------------------------------------------------------

	ERR_WIN STRUCT
		ERR_OLD	dd ?			;c'est le bloc que windows s'attend a trouver	
		ERR_NEW	dd ?			;invers par rapport a la normale
	ERR_WIN ENDS

	
	MEM_EXCEPT	STRUCT
		err_win ERR_WIN	<>		;position impose,rien au dessus 
		Adr_retour		dd ?		;derrire le proc appel
		Chaine_Explique	dd ?			
		Adr_Invoke		dd ?		
		Reg_EBP		dd ?		
		Valeur_Retour	dd ?		
	MEM_EXCEPT	ENDS


	
	;---------------------------------------------------------------------------
	EXCEPT	MACRO NomProc:REQ,parameters:VARARG
		LOCAL Local_Etiquette
		LOCAL localinvoke
		sub esp,sizeof MEM_EXCEPT	;reserve de la place en pile
		mov edx,esp								
		xor eax,eax
		mov (MEM_EXCEPT ptr [edx]).Valeur_Retour,eax	;zero pour l'instant
		mov (MEM_EXCEPT ptr [edx]).Reg_EBP,ebp
		lea eax,localinvoke
		mov (MEM_EXCEPT ptr [edx]).Adr_Invoke,eax
		mov eax,ADRESSE NomProc
		mov (MEM_EXCEPT ptr [edx]).Chaine_Explique,eax
		lea eax,Local_Etiquette
		mov (MEM_EXCEPT ptr [edx]).Adr_retour,eax
		lea eax,HANDLER	;la nouvelle routine d'exceptions
		mov (MEM_EXCEPT ptr [edx]).err_win.ERR_NEW,eax
		assume FS:NOTHING		;masm par dfaut affecte une structure a FS				
		push FS:[0]       	;conserve l'ancien pointeur sur ERR      ;pointeur +0
		pop  (MEM_EXCEPT ptr [edx]).err_win.ERR_OLD
		;windows est content,il a son bloc d'adresse
		mov FS:[0],esp      	;remplacer l'ancien pointeur sur ERR par le nouveau				
		localinvoke:		;---------------ce qui du meme coup sauvegarde esp
		invoke parameters		;rajouter la ligne tel que
		mov edx,esp
		add edx,sizeof MEM_EXCEPT
		mov (MEM_EXCEPT ptr [edx]).Valeur_Retour,eax	
				;tout s'est bien passer,prserve la valeur de retour
		Local_Etiquette:		;adresse ou continuer en cas d'chec
		mov eax,(MEM_EXCEPT ptr [edx]).Valeur_Retour	;envoy par handler
				;prend la valeur de retour ,modifi en cas d'exceptions
		push dword ptr (MEM_EXCEPT ptr [edx]).err_win.ERR_OLD
		pop FS:[0]          	;retablir l'ancien err quand la zone protge est termine
		add esp,sizeof MEM_EXCEPT    	;libere la mmoire pile	
	ENDM


	
	ADRESSE MACRO bidule:REQ
		EXITM <offset CREDATA (bidule)>
	ENDM

