 ;------------------------------------------------------------------------------
 ; File: DXVA.h
 ;
 ; Desc: DirectX Video Acceleration header file.
 ;
 ; Copyright (c) 1999 - 2002, Microsoft Corporation.  All rights reserved.
 ;------------------------------------------------------------------------------
IFNDEF __DIRECTX_VA__

sDXVA_ModeNone	TEXTEQU	<{01b81be00h,0a0c7h,011d3h,(0b9h,084h,000h,0c0h,04fh,02eh,073h,0c5h}}>
sDXVA_ModeH261_A	TEXTEQU	<{01b81be01h,0a0c7h,011d3h,(0b9h,084h,000h,0c0h,04fh,02eh,073h,0c5h}}>
sDXVA_ModeH261_B	TEXTEQU	<{01b81be02h,0a0c7h,011d3h,(0b9h,084h,000h,0c0h,04fh,02eh,073h,0c5h}}>
sDXVA_ModeH263_A	TEXTEQU	<{01b81be03h,0a0c7h,011d3h,(0b9h,084h,000h,0c0h,04fh,02eh,073h,0c5h}}>
sDXVA_ModeH263_B	TEXTEQU	<{01b81be04h,0a0c7h,011d3h,(0b9h,084h,000h,0c0h,04fh,02eh,073h,0c5h}}>
sDXVA_ModeH263_C	TEXTEQU	<{01b81be05h,0a0c7h,011d3h,(0b9h,084h,000h,0c0h,04fh,02eh,073h,0c5h}}>
sDXVA_ModeH263_D	TEXTEQU	<{01b81be06h,0a0c7h,011d3h,(0b9h,084h,000h,0c0h,04fh,02eh,073h,0c5h}}>
sDXVA_ModeH263_E	TEXTEQU	<{01b81be07h,0a0c7h,011d3h,(0b9h,084h,000h,0c0h,04fh,02eh,073h,0c5h}}>
sDXVA_ModeH263_F	TEXTEQU	<{01b81be08h,0a0c7h,011d3h,(0b9h,084h,000h,0c0h,04fh,02eh,073h,0c5h}}>
sDXVA_ModeMPEG1_A	TEXTEQU	<{01b81be09h,0a0c7h,011d3h,(0b9h,084h,000h,0c0h,04fh,02eh,073h,0c5h}}>
sDXVA_ModeMPEG2_A	TEXTEQU	<{01b81be0Ah,0a0c7h,011d3h,(0b9h,084h,000h,0c0h,04fh,02eh,073h,0c5h}}>
sDXVA_ModeMPEG2_B	TEXTEQU	<{01b81be0Bh,0a0c7h,011d3h,(0b9h,084h,000h,0c0h,04fh,02eh,073h,0c5h}}>
sDXVA_ModeMPEG2_C	TEXTEQU	<{01b81be0Ch,0a0c7h,011d3h,(0b9h,084h,000h,0c0h,04fh,02eh,073h,0c5h}}>
sDXVA_ModeMPEG2_D	TEXTEQU	<{01b81be0Dh,0a0c7h,011d3h,(0b9h,084h,000h,0c0h,04fh,02eh,073h,0c5h}}>
sDXVA_ModeWMV8_A	TEXTEQU	<{01b81be80h,0a0c7h,011d3h,(0b9h,084h,000h,0c0h,04fh,02eh,073h,0c5h}}>
sDXVA_ModeWMV8_B	TEXTEQU	<{01b81be81h,0a0c7h,011d3h,(0b9h,084h,000h,0c0h,04fh,02eh,073h,0c5h}}>
sDXVA_ModeWMV9_A	TEXTEQU	<{01b81be90h,0a0c7h,011d3h,(0b9h,084h,000h,0c0h,04fh,02eh,073h,0c5h}}>
sDXVA_ModeWMV9_B	TEXTEQU	<{01b81be91h,0a0c7h,011d3h,(0b9h,084h,000h,0c0h,04fh,02eh,073h,0c5h}}>
sDXVA_ModeWMV9_Ai	TEXTEQU	<{01b81be92h,0a0c7h,011d3h,(0b9h,084h,000h,0c0h,04fh,02eh,073h,0c5h}}>
sDXVA_ModeWMV9_Bi	TEXTEQU	<{01b81be93h,0a0c7h,011d3h,(0b9h,084h,000h,0c0h,04fh,02eh,073h,0c5h}}>
sDXVA_NoEncrypt	TEXTEQU	<{01b81beD0h,0a0c7h,011d3h,(0b9h,084h,000h,0c0h,04fh,02eh,073h,0c5h}}>
DXVA_RESTRICTED_MODE_UNRESTRICTED	equ	<0FFFFh>
DXVA_RESTRICTED_MODE_H261_A	equ	<1>
DXVA_RESTRICTED_MODE_H261_B	equ	<2>
DXVA_RESTRICTED_MODE_H263_A	equ	<3>
DXVA_RESTRICTED_MODE_H263_B	equ	<4>
DXVA_RESTRICTED_MODE_H263_C	equ	<5>
DXVA_RESTRICTED_MODE_H263_D	equ	<6>
DXVA_RESTRICTED_MODE_H263_E	equ	<7>
DXVA_RESTRICTED_MODE_H263_F	equ	<8>
DXVA_RESTRICTED_MODE_MPEG1_A	equ	<9>
DXVA_RESTRICTED_MODE_MPEG2_A	equ	<0Ah>
DXVA_RESTRICTED_MODE_MPEG2_B	equ	<0Bh>
DXVA_RESTRICTED_MODE_MPEG2_C	equ	<0Ch>
DXVA_RESTRICTED_MODE_MPEG2_D	equ	<0Dh>
DXVA_RESTRICTED_MODE_WMV8_A	equ	<080h>
DXVA_RESTRICTED_MODE_WMV8_B	equ	<081h>
DXVA_RESTRICTED_MODE_WMV9_A	equ	<090h>
DXVA_RESTRICTED_MODE_WMV9_B	equ	<091h>
DXVA_RESTRICTED_MODE_WMV9_Ai	equ	<092h>
DXVA_RESTRICTED_MODE_WMV9_Bi	equ	<093h>
DXVA_COMPBUFFER_TYPE_THAT_IS_NOT_USED	equ	<0>
DXVA_PICTURE_DECODE_BUFFER	equ	<1>
DXVA_MACROBLOCK_CONTROL_BUFFER	equ	<2>
DXVA_RESIDUAL_DIFFERENCE_BUFFER	equ	<3>
DXVA_DEBLOCKING_CONTROL_BUFFER	equ	<4>
DXVA_INVERSE_QUANTIZATION_MATRIX_BUFFER	equ	<5>
DXVA_SLICE_CONTROL_BUFFER	equ	<6>
DXVA_BITSTREAM_DATA_BUFFER	equ	<7>
DXVA_AYUV_BUFFER	equ	<8>
DXVA_IA44_SURFACE_BUFFER	equ	<9>
DXVA_DPXD_SURFACE_BUFFER	equ	<10>
DXVA_HIGHLIGHT_BUFFER	equ	<11>
DXVA_DCCMD_SURFACE_BUFFER	equ	<12>
DXVA_ALPHA_BLEND_COMBINATION_BUFFER	equ	<13>
DXVA_PICTURE_RESAMPLE_BUFFER	equ	<14>
DXVA_READ_BACK_BUFFER	equ	<15>
DXVA_NUM_TYPES_COMP_BUFFERS	equ	<16>
 ; values for bDXVA_Func 
DXVA_PICTURE_DECODING_FUNCTION	equ	<1>
DXVA_ALPHA_BLEND_DATA_LOAD_FUNCTION	equ	<2>
DXVA_ALPHA_BLEND_COMBINATION_FUNCTION	equ	<3>
DXVA_PICTURE_RESAMPLE_FUNCTION	equ	<4>
 ; values returned from Execute command in absence of read-back 
DXVA_EXECUTE_RETURN_OK	equ	<0>
DXVA_EXECUTE_RETURN_DATA_ERROR_MINOR	equ	<1>
DXVA_EXECUTE_RETURN_DATA_ERROR_SIGNIF	equ	<2>
DXVA_EXECUTE_RETURN_DATA_ERROR_SEVERE	equ	<3>
DXVA_EXECUTE_RETURN_OTHER_ERROR_SEVERE	equ	<4>
;ECHO    pack(push, BeforeDXVApacking, 1)

DXVA_ConnectMode	STRUCT
	guidMode GUID <> 
	wRestrictedMode WORD ?

DXVA_ConnectMode		ENDS

DXVA_QUERYORREPLYFUNCFLAG_DECODER_PROBE_QUERY	equ	<0FFFFF1h>
DXVA_QUERYORREPLYFUNCFLAG_DECODER_LOCK_QUERY	equ	<0FFFFF5h>
DXVA_QUERYORREPLYFUNCFLAG_ACCEL_PROBE_OK_COPY	equ	<0FFFFF8h>
DXVA_QUERYORREPLYFUNCFLAG_ACCEL_PROBE_OK_PLUS	equ	<0FFFFF9h>
DXVA_QUERYORREPLYFUNCFLAG_ACCEL_LOCK_OK_COPY	equ	<0FFFFFCh>
DXVA_QUERYORREPLYFUNCFLAG_ACCEL_PROBE_FALSE_PLUS	equ	<0FFFFFBh>
DXVA_QUERYORREPLYFUNCFLAG_ACCEL_LOCK_FALSE_PLUS	equ	<0FFFFFFh>
DXVA_ENCRYPTPROTOCOLFUNCFLAG_HOST	equ	<0FFFF00h>
DXVA_ENCRYPTPROTOCOLFUNCFLAG_ACCEL	equ	<0FFFF08h>

DXVA_EncryptProtocolHeader	STRUCT
	dwFunction DWORD ?
	ReservedBits DWORD 3 dup (?)
	guidEncryptProtocol GUID <> 

DXVA_EncryptProtocolHeader		ENDS


DXVA_ConfigPictureDecode	STRUCT
	dwFunction DWORD ?
	dwReservedBits DWORD 3 dup (?)
	guidConfigBitstreamEncryption GUID <> 
	guidConfigMBcontrolEncryption GUID <> 
	guidConfigResidDiffEncryption GUID <> 
	bConfigBitstreamRaw BYTE ?
	bConfigMBcontrolRasterOrder BYTE ?
	bConfigResidDiffHost BYTE ?
	bConfigSpatialResid8 BYTE ?
	bConfigResid8Subtraction BYTE ?
	bConfigSpatialHost8or9Clipping BYTE ?
	bConfigSpatialResidInterleaved BYTE ?
	bConfigIntraResidUnsigned BYTE ?
	bConfigResidDiffAccelerator BYTE ?
	bConfigHostInverseScan BYTE ?
	bConfigSpecificIDCT BYTE ?
	bConfig4GroupedCoefs BYTE ?

DXVA_ConfigPictureDecode		ENDS

 ; Picture Decoding Parameters 

DXVA_PictureParameters	STRUCT
	wDecodedPictureIndex WORD ?
	wDeblockedPictureIndex WORD ?
	wForwardRefPictureIndex WORD ?
	wBackwardRefPictureIndex WORD ?
	wPicWidthInMBminus1 WORD ?
	wPicHeightInMBminus1 WORD ?
	bMacroblockWidthMinus1 BYTE ?
	bMacroblockHeightMinus1 BYTE ?
	bBlockWidthMinus1 BYTE ?
	bBlockHeightMinus1 BYTE ?
	bBPPminus1 BYTE ?
	bPicStructure BYTE ?
	bSecondField BYTE ?
	bPicIntra BYTE ?
	bPicBackwardPrediction BYTE ?
	bBidirectionalAveragingMode BYTE ?
	bMVprecisionAndChromaRelation BYTE ?
	bChromaFormat BYTE ?
	bPicScanFixed BYTE ?
	bPicScanMethod BYTE ?
	bPicReadbackRequests BYTE ?
	bRcontrol BYTE ?
	bPicSpatialResid8 BYTE ?
	bPicOverflowBlocks BYTE ?
	bPicExtrapolation BYTE ?
	bPicDeblocked BYTE ?
	bPicDeblockConfined BYTE ?
	bPic4MVallowed BYTE ?
	bPicOBMC BYTE ?
	bPicBinPB BYTE ?
	bMV_RPS BYTE ?
	bReservedBits BYTE ?
	wBitstreamFcodes WORD ?
	wBitstreamPCEelements WORD ?
	bBitstreamConcealmentNeed BYTE ?
	bBitstreamConcealmentMethod BYTE ?

DXVA_PictureParameters		ENDS

 ; Picture Resampling 

DXVA_PicResample	STRUCT
	wPicResampleSourcePicIndex WORD ?
	wPicResampleDestPicIndex WORD ?
	wPicResampleRcontrol WORD ?
	bPicResampleExtrapWidth BYTE ?
	bPicResampleExtrapHeight BYTE ?
	dwPicResampleSourceWidth DWORD ?
	dwPicResampleSourceHeight DWORD ?
	dwPicResampleDestWidth DWORD ?
	dwPicResampleDestHeight DWORD ?
	dwPicResampleFullDestWidth DWORD ?
	dwPicResampleFullDestHeight DWORD ?

DXVA_PicResample		ENDS

DXVA_CHROMA_FORMAT_420	equ	<1>
DXVA_CHROMA_FORMAT_422	equ	<2>
DXVA_CHROMA_FORMAT_444	equ	<3>
DXVA_PICTURE_STRUCTURE_TOP_FIELD	equ	<1>
DXVA_PICTURE_STRUCTURE_BOTTOM_FIELD	equ	<2>
DXVA_PICTURE_STRUCTURE_FRAME	equ	<3>
DXVA_BIDIRECTIONAL_AVERAGING_MPEG2_ROUND	equ	<0>
DXVA_BIDIRECTIONAL_AVERAGING_H263_TRUNC	equ	<1>
DXVA_MV_PRECISION_AND_CHROMA_RELATION_MPEG2	equ	<0>
DXVA_MV_PRECISION_AND_CHROMA_RELATION_H263	equ	<1>
DXVA_MV_PRECISION_AND_CHROMA_RELATION_H261	equ	<2>
DXVA_SCAN_METHOD_ZIG_ZAG	equ	<0>
DXVA_SCAN_METHOD_ALTERNATE_VERTICAL	equ	<1>
DXVA_SCAN_METHOD_ALTERNATE_HORIZONTAL	equ	<2>
DXVA_SCAN_METHOD_ARBITRARY	equ	<3>
DXVA_BITSTREAM_CONCEALMENT_NEED_UNLIKELY	equ	<0>
DXVA_BITSTREAM_CONCEALMENT_NEED_MILD	equ	<1>
DXVA_BITSTREAM_CONCEALMENT_NEED_LIKELY	equ	<2>
DXVA_BITSTREAM_CONCEALMENT_NEED_SEVERE	equ	<3>
DXVA_BITSTREAM_CONCEALMENT_METHOD_UNSPECIFIED	equ	<0>
DXVA_BITSTREAM_CONCEALMENT_METHOD_INTRA	equ	<1>
DXVA_BITSTREAM_CONCEALMENT_METHOD_FORWARD	equ	<2>
DXVA_BITSTREAM_CONCEALMENT_METHOD_BACKWARD	equ	<3>
 ; Buffer Description Data 

DXVA_BufferDescription	STRUCT
	dwTypeIndex DWORD ?
	dwBufferIndex DWORD ?
	dwDataOffset DWORD ?
	dwDataSize DWORD ?
	dwFirstMBaddress DWORD ?
	dwNumMBsInBuffer DWORD ?
	dwWidth DWORD ?
	dwHeight DWORD ?
	dwStride DWORD ?
	dwReservedBits DWORD ?

DXVA_BufferDescription		ENDS

 ; Off-Host IDCT Coefficient Data Structures 

DXVA_TCoef4Group	STRUCT
	TCoefIDX BYTE 4 dup (?)
	TCoefValue WORD 4 dup (?)

DXVA_TCoef4Group		ENDS


DXVA_TCoefSingle	STRUCT
	wIndexWithEOB WORD ?
	TCoefValue WORD ?

DXVA_TCoefSingle		ENDS

 ; Macros for Reading EOB and Index Values 
 ; Macro for Writing EOB and Index Values 
 ; Spatial-Domain Residual Difference Blocks 
DXVA_USUAL_BLOCK_WIDTH	equ	<8>
DXVA_USUAL_BLOCK_HEIGHT	equ	<8>
DXVA_USUAL_BLOCK_SIZE	equ	<DXVA_USUAL_BLOCK_WIDTH *  DXVA_USUAL_BLOCK_HEIGHT>
 ; Deblocking Filter Control Structure 
 ; Macros for Reading STRENGTH and FilterOn 
 ; Macro for Writing STRENGTH and FilterOn 
 ; Macroblock Control Command Data Structures 

DXVA_MVvalue	STRUCT
	horz WORD ?

DXVA_MVvalue		ENDS

 ; Inverse Quantization Matrices 

DXVA_QmatrixData	STRUCT
	bNewQmatrix BYTE 4 dup (?)  ; intra Y, inter Y, intra chroma, inter chroma 
	Qmatrix WORD [4][DXVA_USUAL_BLOCK_WIDTH * DXVA_USUAL_BLOCK_HEIGHT] dup (?)

DXVA_QmatrixData		ENDS
;erreur traduction
;typedef struct _DXVA_QmatrixData {
;  BYTE bNewQmatrix[4]; /* intra Y, inter Y, intra chroma, inter chroma */
;  WORD Qmatrix[4][DXVA_USUAL_BLOCK_WIDTH * DXVA_USUAL_BLOCK_HEIGHT];
;} DXVA_QmatrixData, *LPDXVA_QmatrixData;


 ; Slice Control Buffer Data 

DXVA_SliceInfo	STRUCT
	wHorizontalPosition WORD ?
	wVerticalPosition WORD ?
	dwSliceBitsInBuffer DWORD ?
	dwSliceDataLocation DWORD ?
	bStartCodeBitOffset BYTE ?
	bReservedBits BYTE ?
	wMBbitOffset WORD ?
	wNumberMBsInSlice WORD ?
	wQuantizerScaleCode WORD ?
	wBadSliceChopping WORD ?

DXVA_SliceInfo		ENDS

DXVA_NumMV_OBMC_off_BinPBwith4MV_off	equ	<4>
DXVA_NumMV_OBMC_off_BinPBwith4MV_on	equ	<4 +  1>
DXVA_NumMV_OBMC_on__BinPB_off	equ	<10>
DXVA_NumMV_OBMC_on__BinPB_on	equ	<11>
DXVA_NumBlocksPerMB_420	equ	<4 +  2 +  0>
DXVA_NumBlocksPerMB_422	equ	<4 +  2 +  2>
DXVA_NumBlocksPerMB_444	equ	<4 +  4 +  4>
 ; Basic form for I pictures 
 ; Host Residual Differences 

DXVA_MBctrl_I_HostResidDiff_1	STRUCT
	wMBaddress WORD ?
	wMBtype WORD ?
	dwMB_SNL DWORD ?
	wPatternCode WORD ?
	wPC_Overflow WORD ?  ; zero if not overflow format 
	dwReservedBits2 DWORD ?

DXVA_MBctrl_I_HostResidDiff_1		ENDS

 ; Basic form for I pictures 
 ; Off-Host IDCT, 4:2:0 sampling 

DXVA_MBctrl_I_OffHostIDCT_1	STRUCT
	wMBaddress WORD ?
	wMBtype WORD ?
	dwMB_SNL DWORD ?
	wPatternCode WORD ?
	bNumCoef BYTE DXVA_NumBlocksPerMB_420 dup (?)

DXVA_MBctrl_I_OffHostIDCT_1		ENDS

 ; Basic form for P and B pictures 
 ; Should also be used for concealment MVs in MPEG-2 I pictures 
 ; Without OBMC, without BinPB and 4MV together, without MV RPS 
 ; Host Residual Differences 

DXVA_MBctrl_P_HostResidDiff_1	STRUCT
	wMBaddress WORD ?
	wMBtype WORD ?
	dwMB_SNL DWORD ?
	wPatternCode WORD ?
	wPC_Overflow WORD ?  ; zero if not overflow format 
	dwReservedBits2 DWORD ?
	MVector DXVA_MVvalue DXVA_NumMV_OBMC_off_BinPBwith4MV_off dup (<>)

DXVA_MBctrl_P_HostResidDiff_1		ENDS

 ; Basic form for P and B pictures 
 ; Without OBMC, without BinPB and 4MV together, without MV RPS 
 ; Off-Host IDCT, 4:2:0 sampling 

DXVA_MBctrl_P_OffHostIDCT_1	STRUCT
	wMBaddress WORD ?
	wMBtype WORD ?
	dwMB_SNL DWORD ?
	wPatternCode WORD ?
	bNumCoef BYTE DXVA_NumBlocksPerMB_420 dup (?)
	MVector DXVA_MVvalue DXVA_NumMV_OBMC_off_BinPBwith4MV_off dup (<>)

DXVA_MBctrl_P_OffHostIDCT_1		ENDS

 ; How to load alpha blending graphic data 

DXVA_ConfigAlphaLoad	STRUCT
	dwFunction DWORD ?
	dwReservedBits DWORD 3 dup (?)
	bConfigDataType BYTE ?

DXVA_ConfigAlphaLoad		ENDS

DXVA_CONFIG_DATA_TYPE_IA44	equ	<0>
DXVA_CONFIG_DATA_TYPE_AI44	equ	<1>
DXVA_CONFIG_DATA_TYPE_DPXD	equ	<2>
DXVA_CONFIG_DATA_TYPE_AYUV	equ	<3>
 ; How to combine alpha blending graphic data 

DXVA_ConfigAlphaCombine	STRUCT
	dwFunction DWORD ?
	dwReservedBits DWORD 3 dup (?)
	bConfigBlendType BYTE ?
	bConfigPictureResizing BYTE ?
	bConfigOnlyUsePicDestRectArea BYTE ?
	bConfigGraphicResizing BYTE ?
	bConfigWholePlaneAlpha BYTE ?

DXVA_ConfigAlphaCombine		ENDS

DXVA_CONFIG_BLEND_TYPE_FRONT_BUFFER	equ	<0>
DXVA_CONFIG_BLEND_TYPE_BACK_HARDWARE	equ	<1>
 ; AYUV sample for 16-entry YUV palette or graphic surface 

DXVA_AYUVsample2	STRUCT
	bCrValue BYTE ?
	bCbValue BYTE ?
	bY_Value BYTE ?
	bSampleAlpha8 BYTE ?

DXVA_AYUVsample2		ENDS

 ; Macros for IA44 alpha blending surface samples 
 ; Macros for AI44 alpha blending surface samples 
 ; Highlight data structure 

DXVA_Highlight	STRUCT
	wHighlightActive WORD ?
	wHighlightIndices WORD ?
	wHighlightAlphas WORD ?
	HighlightRect RECT <> 

DXVA_Highlight		ENDS

 ; Alpha blend combination 

DXVA_BlendCombination	STRUCT
	wPictureSourceIndex WORD ?
	wBlendedDestinationIndex WORD ?
	PictureSourceRect16thPel RECT <> 
	PictureDestinationRect RECT <> 
	GraphicSourceRect RECT <> 
	GraphicDestinationRect RECT <> 
	wBlendDelay WORD ?
	bBlendOn BYTE ?
	bWholePlaneAlpha BYTE ?
	OutsideYUVcolor DXVA_AYUVsample2 <> 

DXVA_BlendCombination		ENDS

;ECHO    pack(push, 16)
;ECHO    pack(pop)
 ;
;* Other forms of pictures are constructed in the obvious way
;* from the above by adjusting the number of residual difference
;* blocks, the number of motion vectors per macroblock, etc.
;*/
;ECHO    pack(pop, BeforeDXVApacking)
 ; -------------------------------------------------------------------------
 ;
 ; The definitions that follow describe the video de-interlace interface
 ; between the VMR and the graphics device driver.  This interface is not
 ; accessable via the IAMVideoAccelerator interface.
 ;
 ; -------------------------------------------------------------------------
 ;
IFNDEF __DIRECTX_VA_DEINTERLACE__
sDXVA_DeinterlaceBobDevice	TEXTEQU	<{0335aa36eh,07884h,043a4h,(09ch,091h,07fh,087h,0fah,0f3h,0e3h,07eh}}>
sDXVA_DeinterlaceContainerDevice	TEXTEQU	<{00e85cb93h,03046h,04ff0h,(0aeh,0cch,0d5h,08ch,0b5h,0f0h,035h,0fdh}}>
IF (COMPARE (DIRECT3D_VERSION,LT,00800h))

;erreur traduction , pris pour une structure
;typedef DWORD D3DFORMAT;
;D3DPOOL enum sans nom
D3DPOOL	UNION
	D3DPOOL_DEFAULT	DWORD 0 
	D3DPOOL_MANAGED	DWORD 1 
	D3DPOOL_SYSTEMMEM	DWORD 2 
	D3DPOOL_SCRATCH	DWORD 3 
	D3DPOOL_LOCALVIDMEM	DWORD 4 
	D3DPOOL_NONLOCALVIDMEM	DWORD 5 
	D3DPOOL_FORCE_DWORD	DWORD 07fffffffh 
D3DPOOL	ENDS


ENDIF 
 ; -------------------------------------------------------------------------
 ; data structures shared by User mode and Kernel mode.
 ; -------------------------------------------------------------------------
 ;

DXVA_SampleFormat	UNION
	DXVA_SamplePreviousFrame	DWORD 1 
	DXVA_SampleProgressiveFrame	DWORD 2 
	DXVA_SampleFieldInterleavedEvenFirst	DWORD 3 
	DXVA_SampleFieldInterleavedOddFirst	DWORD 4 
	DXVA_SampleFieldSingleEven	DWORD 5 
	DXVA_SampleFieldSingleOdd	DWORD 6 
DXVA_SampleFormat		ENDS



DXVA_Frequency	STRUCT
	Numerator DWORD ?
	Denominator DWORD ?

DXVA_Frequency		ENDS


DXVA_VideoDesc	STRUCT
	masmsize DWORD ?
	SampleWidth DWORD ?
	SampleHeight DWORD ?
	SampleFormat DXVA_SampleFormat <> 
	d3dFormat DWORD ?
	InputSampleFreq DXVA_Frequency <> 
	OutputFrameFreq DXVA_Frequency <> 

DXVA_VideoDesc		ENDS


DXVA_VideoProcessCaps	UNION
	DXVA_VideoProcess_None	DWORD 00000h 
	DXVA_VideoProcess_YUV2RGB	DWORD 00001h 
	DXVA_VideoProcess_StretchX	DWORD 00002h 
	DXVA_VideoProcess_StretchY	DWORD 00004h 
	DXVA_VideoProcess_AlphaBlend	DWORD 00008h 
	DXVA_VideoProcess_SubRects	DWORD 00010h 
DXVA_VideoProcessCaps		ENDS



DXVA_DeinterlaceTech	UNION
	DXVA_DeinterlaceTech_Unknown	DWORD 00000h 
	DXVA_DeinterlaceTech_BOBLineReplicate	DWORD 00001h 
	DXVA_DeinterlaceTech_BOBVerticalStretch	DWORD 00002h 
	DXVA_DeinterlaceTech_MedianFiltering	DWORD 00004h 
	DXVA_DeinterlaceTech_EdgeFiltering	DWORD 00010h 
	DXVA_DeinterlaceTech_FieldAdaptive	DWORD 00020h 
	DXVA_DeinterlaceTech_PixelAdaptive	DWORD 00040h 
	DXVA_DeinterlaceTech_MotionVectorSteered	DWORD 00080h 
DXVA_DeinterlaceTech		ENDS



DXVA_VideoSample	STRUCT
	rtStart QWORD ?
	rtEnd QWORD ?
	SampleFormat DXVA_SampleFormat <> 
	lpDDSSrcSurface DWORD ?

DXVA_VideoSample		ENDS


DXVA_DeinterlaceCaps	STRUCT
	masmsize DWORD ?
	NumPreviousOutputFrames DWORD ?
	InputPool DWORD ?
	NumForwardRefSamples DWORD ?
	NumBackwardRefSamples DWORD ?
	d3dOutputFormat DWORD ?
	VideoProcessingCaps DXVA_VideoProcessCaps <> 
	DeinterlaceTechnology DXVA_DeinterlaceTech <> 

DXVA_DeinterlaceCaps		ENDS

 ; -------------------------------------------------------------------------
 ; Data types used with RenderMoComp in kernel mode
 ; -------------------------------------------------------------------------
 ;
 ; Function codes for RenderMoComp
MAX_DEINTERLACE_SURFACES	equ	<32>

DXVA_DeinterlaceBlt	STRUCT
	masmsize DWORD ?
	Reserved DWORD ?
	rtTarget QWORD ?
	DstRect RECT <> 
	SrcRect RECT <> 
	NumSourceSurfaces DWORD ?
	Alpha REAL4 ?
	Source DXVA_VideoSample MAX_DEINTERLACE_SURFACES dup (<>)

DXVA_DeinterlaceBlt		ENDS

DXVA_DeinterlaceBltFnCode	equ	<001h>
 ; lpInput => DXVA_DeinterlaceBlt*
 ; lpOuput => NULL /* not currently used */
MAX_DEINTERLACE_DEVICE_GUIDS	equ	<32>

DXVA_DeinterlaceQueryAvailableModes	STRUCT
	masmsize DWORD ?
	NumGuids DWORD ?
	Guids GUID MAX_DEINTERLACE_DEVICE_GUIDS dup (<>)

DXVA_DeinterlaceQueryAvailableModes		ENDS

DXVA_DeinterlaceQueryAvailableModesFnCode	equ	<001h>
 ; lpInput => DXVA_VideoDesc*
 ; lpOuput => DXVA_DeinterlaceQueryAvailableModes*

DXVA_DeinterlaceQueryModeCaps	STRUCT
	masmsize DWORD ?
	Guid GUID <> 
	VideoDesc DXVA_VideoDesc <> 

DXVA_DeinterlaceQueryModeCaps		ENDS

DXVA_DeinterlaceQueryModeCapsFnCode	equ	<002h>
 ; lpInput => DXVA_DeinterlaceQueryModeCaps*
 ; lpOuput => DXVA_DeinterlaceCaps*
ENDIF  ;  __DIRECTX_VA_DEINTERLACE__ 
 ; -------------------------------------------------------------------------
 ;
 ; The definitions that follow describe the video ProcAmp interface
 ; between the VMR and the graphics device driver.  This interface is not
 ; accessable via the IAMVideoAccelerator interface.
 ;
 ; -------------------------------------------------------------------------
 ;
IFNDEF __DIRECTX_VA_PROCAMPCONTROL__
sDXVA_ProcAmpControlDevice	TEXTEQU	<{09f200913h,02ffdh,04056h,(09fh,01eh,0e1h,0b5h,008h,0f2h,02dh,0cfh}}>

DXVA_ProcAmpControlProp	UNION
	DXVA_ProcAmp_None	DWORD 00000h 
	DXVA_ProcAmp_Brightness	DWORD 00001h 
	DXVA_ProcAmp_Contrast	DWORD 00002h 
	DXVA_ProcAmp_Hue	DWORD 00004h 
	DXVA_ProcAmp_Saturation	DWORD 00008h 
DXVA_ProcAmpControlProp		ENDS



DXVA_ProcAmpControlCaps	STRUCT
	masmsize DWORD ?
	InputPool DWORD ?
	d3dOutputFormat DWORD ?
	ProcAmpControlProps DWORD ?  ; see DXVA_ProcAmpControlProp
	VideoProcessingCaps DWORD ?  ; see DXVA_VideoProcessCaps

DXVA_ProcAmpControlCaps		ENDS

DXVA_ProcAmpControlQueryCapsFnCode	equ	<003h>
 ; lpInput => DXVA_VideoDesc*
 ; lpOuput => DXVA_ProcAmpControlCaps*

DXVA_ProcAmpControlQueryRange	STRUCT
	masmsize DWORD ?
	ProcAmpControlProp DXVA_ProcAmpControlProp <> 
	VideoDesc DXVA_VideoDesc <> 

DXVA_ProcAmpControlQueryRange		ENDS


DXVA_VideoPropertyRange	STRUCT
	MinValue REAL4 ?
	MaxValue REAL4 ?
	DefaultValue REAL4 ?
	StepSize REAL4 ?

DXVA_VideoPropertyRange		ENDS

DXVA_ProcAmpControlQueryRangeFnCode	equ	<004h>
 ; lpInput => DXVA_ProcAmpControlQueryRange*
 ; lpOuput => DXVA_VideoPropertyRange*

DXVA_ProcAmpControlBlt	STRUCT
	masmsize DWORD ?
	DstRect RECT <> 
	SrcRect RECT <> 
	Alpha REAL4 ?
	Brightness REAL4 ?
	Contrast REAL4 ?
	Hue REAL4 ?
	Saturation REAL4 ?

DXVA_ProcAmpControlBlt		ENDS

DXVA_ProcAmpControlBltFnCode	equ	<001h>
 ; lpInput => DXVA_ProcAmpControlBlt*
 ; lpOuput => NULL /* not currently used */
ENDIF  ;  __DIRECTX_VA_PROCAMPCONTROL__ 
IFDEF __cplusplus
ENDIF 
ENDIF  ; __DIRECTX_VA__ 
